#!/usr/bin/python

########################################################################
# ca-index.py 
# (c) by Michael Stroeder, michael.stroeder@inka.de
########################################################################

Version='0.5.3'

########################################################################
# This CGI-BIN program shows a pretty index of the CA definitions in
# OpenSSL's config file (e.g. named openssl.cnf)
########################################################################

import os, sys, types, string, pycacnf, openssl, htmlbase

from pycacnf import opensslcnf, pyca_section

# **********************************************************
# ********************* Hauptprogramm **********************
# **********************************************************

nsGetCertUrl = pyca_section.get('nsGetCertUrl','')
nsEnrollUrl  = pyca_section.get('nsEnrollUrl','')

ca_names = opensslcnf.sectionkeys.get('ca',[])

if not ca_names:
  htmlbase.PrintErrorMsg('No certificate authorities found.')
  sys.exit(0)

htmlbase.PrintHeader('Overview of certificate authorities')
htmlbase.PrintHeading('Overview of certificate authorities')
print """<TABLE BORDER WIDTH=100%>
<TR>
  <TH>Download CA<BR>certificate</TH>
  <TH>Download<BR>CRL</TH>
  <TH>certificate<BR>types</TH>
  <TH>Comment</TH>
  <TH>View policy</TH>
</TR>
"""

for ca_name in ca_names:
  ca = opensslcnf.getcadata(ca_name)
  if nsEnrollUrl and opensslcnf.isclientcert(ca_name):
    nsCertTypeStr = '<A HREF="%s%s/%s">%s</A>' % (ca.nsBaseUrl,nsEnrollUrl,ca_name,ca.nsCertTypeStr)
  else:
    nsCertTypeStr = '%s' % (ca.nsCertTypeStr)
  if ca.nsCaRevocationUrl:
    nsCaRevocationUrl='<A HREF="%s%s">CRL of %s</A>' % (ca.nsBaseUrl,ca.nsCaRevocationUrl,ca_name)
  else:
    nsCaRevocationUrl='-'
  if ca.nsCaPolicyUrl:
    nsCaPolicyUrl='<A HREF="%s%s">Policy of %s</A>' % (ca.nsBaseUrl,ca.nsCaPolicyUrl,ca_name)
  else:
    nsCaPolicyUrl='-'
      
  print '<TR><TD><A HREF="%s%s/%s/ca">%s</A></TD>' % (ca.nsBaseUrl,nsGetCertUrl,ca_name,ca_name)
  print '<TD>%s</TD><TD>%s</TD><TD>%s</TD><TD>%s</TD><TR>' % (nsCaRevocationUrl,nsCertTypeStr,ca.nsComment,nsCaPolicyUrl)

print '</TABLE><P>'

print '<A HREF="cert-query.py">Search for e-mail certificates.</A>'

htmlbase.PrintFooter()
sys.exit(0)
