##############################################################################
# cgissl.py 0.2.1
# (C) 1998 by Michael Stroeder
##############################################################################

import os, re, string, charset

##############################################################################
# Feststellen der SSL-Sicherheitsstufe
##############################################################################

def SecLevel(acceptedciphers,valid_dn='',valid_idn=''):

  seclevel = 0

  # SSL-Verbindung?
  if os.environ.has_key('HTTPS') and \
     string.lower(os.environ['HTTPS'])=='on' and \
     os.environ['SSL_CIPHER'] in acceptedciphers:

    if os.environ.has_key('SSL_CLIENT_DN'):

      ssl_client_dn = os.environ['SSL_CLIENT_DN']
      dn_rm = re.compile(valid_dn).match(ssl_client_dn)

      if os.environ.has_key('SSL_CLIENT_IDN'):
        ssl_client_idn = os.environ['SSL_CLIENT_IDN']
      elif os.environ.has_key('SSL_CLIENT_I_DN'):
        ssl_client_idn = os.environ['SSL_CLIENT_I_DN']
      else:
        ssl_client_idn=''

      idn_rm = re.compile(valid_idn).match(ssl_client_idn)
    
      if (dn_rm and dn_rm.group(0)==ssl_client_dn) and \
	 (idn_rm and idn_rm.group(0)==ssl_client_idn):
	seclevel = 2
      else:  
	seclevel = 1

    else:  
      seclevel = 1

  return seclevel


##############################################################################
# HTML-Darstellung der Sicherheitsinformation
##############################################################################

def PrintSecInfo(acceptedciphers,valid_dn='',valid_idn=''):

  seclevel = SecLevel(acceptedciphers,valid_dn,valid_idn)

  print 'Current security level is: <STRONG>%d</STRONG><P>' % (seclevel)

  if seclevel>=1:
    print 'You connected with cipher <STRONG>%s</STRONG>, key size <STRONG>%s Bit</STRONG>, secret key size <STRONG>%s Bit</STRONG>.<P>' % (
            os.environ['SSL_CIPHER'],
	    os.environ['HTTPS_KEYSIZE'],
	    os.environ['HTTPS_SECRETKEYSIZE']
	  )
  if seclevel>=2:
    ssl_client_dn = os.environ['SSL_CLIENT_DN']
    if os.environ.has_key('SSL_CLIENT_IDN'):
      ssl_client_idn = os.environ['SSL_CLIENT_IDN']
    elif os.environ.has_key('SSL_CLIENT_I_DN'):
      ssl_client_idn = os.environ['SSL_CLIENT_I_DN']
    else:
      ssl_client_idn=''
    print 'Your client sent the following certificate:<TABLE BORDER=1><TR><TD>%s</TD><TD>%s</TD></TR></TABLE><P>' % (
           string.join(string.split(charset.trans(ssl_client_dn[1:],charset.t61,charset.html),'/'),'<BR>'),
	   string.join(string.split(charset.trans(ssl_client_idn[1:],charset.t61,charset.html),'/'),'<BR>')
	  )
  print """<TABLE NOBORDER CELLSPACING=5%%>
	   <TR>
	     <TD ALIGN=MIDDLE WIDTH=10%%>0</TD><TD>no encryption at all</TD>
	   </TR>
	   <TR>
	     <TD ALIGN=MIDDLE>1</TD>
	     <TD>Session is encrypted with SSL and cipher is accepted</TD>
	   </TR>
	   <TR>
	     <TD ALIGN=MIDDLE>2</TD>
	     <TD>Client presented valid certificate,<BR>
	     the DN of the certified object matches "<CODE>%s</CODE>"<BR>
	     and the DN of the certifier matches "<CODE>%s</CODE>"</TD>
	   </TR>
	   </TABLE>""" % (valid_dn,valid_idn)
